var search_data = {"index":{"searchIndex":["math2d","utils2d","vector2d","object","*()","+()","-()","-@()","/()","angle_between()","clamp()","clamp()","constrain()","constrain()","cross()","distance()","distance()","dot()","dot_grid_gradient()","down()","from_angle()","grayscale()","heading()","left()","lerp()","lerp()","limit()","magnitude()","map()","negate()","new()","noise()","normalize()","normalize()","normalized?()","one()","random()","random_gradient()","ratio()","reflect()","right()","rotate()","rotate_around()","set()","set_magnitude()","squared()","to_a()","to_deg()","to_rad()","to_s()","to_vector()","unit()","unit?()","up()","y_heading()","zero()"],"longSearchIndex":["math2d","math2d::utils2d","math2d::vector2d","object","math2d::vector2d#*()","math2d::vector2d#+()","math2d::vector2d#-()","math2d::vector2d#-@()","math2d::vector2d#/()","math2d::vector2d#angle_between()","math2d::utils2d::clamp()","math2d::vector2d#clamp()","math2d::utils2d::constrain()","math2d::vector2d#constrain()","math2d::vector2d#cross()","math2d::utils2d::distance()","math2d::vector2d#distance()","math2d::vector2d#dot()","math2d::utils2d::dot_grid_gradient()","math2d::vector2d::down()","math2d::vector2d::from_angle()","math2d::utils2d::grayscale()","math2d::vector2d#heading()","math2d::vector2d::left()","math2d::utils2d::lerp()","math2d::vector2d#lerp()","math2d::vector2d#limit()","math2d::vector2d#magnitude()","math2d::utils2d::map()","math2d::vector2d#negate()","math2d::vector2d::new()","math2d::utils2d::noise()","math2d::utils2d::normalize()","math2d::vector2d#normalize()","math2d::vector2d#normalized?()","math2d::vector2d::one()","math2d::vector2d::random()","math2d::utils2d::random_gradient()","math2d::vector2d#ratio()","math2d::vector2d#reflect()","math2d::vector2d::right()","math2d::vector2d#rotate()","math2d::vector2d#rotate_around()","math2d::vector2d#set()","math2d::vector2d#set_magnitude()","math2d::vector2d#squared()","math2d::vector2d#to_a()","math2d::utils2d::to_deg()","math2d::utils2d::to_rad()","math2d::vector2d#to_s()","math2d::vector2d::to_vector()","math2d::vector2d#unit()","math2d::vector2d#unit?()","math2d::vector2d::up()","math2d::vector2d#y_heading()","math2d::vector2d::zero()"],"info":[["Math2D","","Math2D.html","","<p>Namespace for the Math2D library\n<p>@author Ualace Henrique &lt;ualacehenrique@hotmail.com&gt;\n<p>Namespace for …\n"],["Math2D::Utils2D","","Math2D/Utils2D.html","","<p>A collection of useful Mathematical tools in 2D space\n<p>@author Ualace Henrique &lt;ualacehenrique@hotmail.com&gt; …\n"],["Math2D::Vector2D","","Math2D/Vector2D.html","","<p>Vector2D\n<p>An implementation of various 2-dimensional vector methods.\n\n<p>@author Ualace Henrique &lt;ualacehenrique@hotmail.com&gt; …\n"],["Object","","Object.html","",""],["*","Math2D::Vector2D","Math2D/Vector2D.html#method-i-2A","(other)","<p>Multiplies <code>self</code> by another vector or by a scalar.\n<p>@param [Numeric, Vector2D] other @return [Vector2D] …\n"],["+","Math2D::Vector2D","Math2D/Vector2D.html#method-i-2B","(other)","<p>Adds <code>self</code> to another vector or to a scalar.\n<p>@param [Numeric, Vector2D] other @return [Vector2D]\n"],["-","Math2D::Vector2D","Math2D/Vector2D.html#method-i-2D","(other)","<p>Subtracts <code>self</code> to another vector or to a scalar.\n<p>@param [Numeric, Vector2D] other @return [Vector2D]\n"],["-@","Math2D::Vector2D","Math2D/Vector2D.html#method-i-2D-40","()","<p>Negates both x and y values of <code>self</code> and returns a new Vector2D.\n<p>@return [Vector2D]\n"],["/","Math2D::Vector2D","Math2D/Vector2D.html#method-i-2F","(other)","<p>Divides <code>self</code> by another vector or by a scalar.\n<p>@param [Numeric, Vector2D] other @return [Vector2D]\n"],["angle_between","Math2D::Vector2D","Math2D/Vector2D.html#method-i-angle_between","(other)","<p>Returns the angle between <code>self</code> and <code>other</code> in radians.\n<p>@param [Vector2D] other @return [Float]\n"],["clamp","Math2D::Utils2D","Math2D/Utils2D.html#method-c-clamp","(x, a, b)",""],["clamp","Math2D::Vector2D","Math2D/Vector2D.html#method-i-clamp","(a, b)",""],["constrain","Math2D::Utils2D","Math2D/Utils2D.html#method-c-constrain","(x, a, b)","<p>Constrains a value <code>x</code> between a minimum value <code>a</code> and maximum value <code>b</code>.\n<p>@param [Numeric] x @param [Numeric] …\n"],["constrain","Math2D::Vector2D","Math2D/Vector2D.html#method-i-constrain","(a, b)","<p>Constrains the magnitude of <code>self</code> between a minimum value <code>a</code> and maximum value <code>b</code>.\n<p>@note I haven&#39;t experienced …\n"],["cross","Math2D::Vector2D","Math2D/Vector2D.html#method-i-cross","(other)","<p>Calculates the cross product between <code>self</code> and <code>other</code>, where: AxB (A cross B) = (Ax * By) - (Bx * Ay)  …\n"],["distance","Math2D::Utils2D","Math2D/Utils2D.html#method-c-distance","(x1, y1, x2, y2)","<p>Returns the distance between two cartesian points.\n<p>@param [Numeric] x1 @param [Numeric] y1 @param [Numeric] …\n"],["distance","Math2D::Vector2D","Math2D/Vector2D.html#method-i-distance","(other)","<p>Returns the Euclidean distance between <code>self</code> and <code>other</code>.\n<p>@param [Vector2D] other @return [Float]\n"],["dot","Math2D::Vector2D","Math2D/Vector2D.html#method-i-dot","(other)","<p>Calculates the dot product between <code>self</code> and <code>other</code>, where: A.B (A dot B) = (Ax * Bx) + (Ay * By)\n<p>@param …\n"],["dot_grid_gradient","Math2D::Utils2D","Math2D/Utils2D.html#method-c-dot_grid_gradient","(ix, iy, x, y)","<p>@private @see en.wikipedia.org/wiki/Perlin_noise\n"],["down","Math2D::Vector2D","Math2D/Vector2D.html#method-c-down","()","<p>Shorthand for writing Vector2D.new(0, 1).\n<p>@return [Vector2D]\n"],["from_angle","Math2D::Vector2D","Math2D/Vector2D.html#method-c-from_angle","(theta, len = 1)","<p>Returns a new Vector2D from a given angle <code>theta</code> with length <code>len</code>.\n<p>@param [Numeric] theta @param [Numeric] …\n"],["grayscale","Math2D::Utils2D","Math2D/Utils2D.html#method-c-grayscale","(val = nil)","<p>If no argument is passed, randomly generates a greyscale RGB array. Otherwise, returns a greyscale array …\n"],["heading","Math2D::Vector2D","Math2D/Vector2D.html#method-i-heading","()","<p>Returns the x-heading angle of <code>self</code> in radians. The x-heading angle is the angle formed between <code>self</code> …\n"],["left","Math2D::Vector2D","Math2D/Vector2D.html#method-c-left","()","<p>Shorthand for writing Vector2D.new(-1, 0).\n<p>@return [Vector2D]\n"],["lerp","Math2D::Utils2D","Math2D/Utils2D.html#method-c-lerp","(a, b, amt)","<p>Calculates a number between two numbers at a specific increment. The amt parameter is the amount to interpolate …\n"],["lerp","Math2D::Vector2D","Math2D/Vector2D.html#method-i-lerp","(other, amt)","<p>Linear interpolate <code>self</code> and <code>other</code> with an amount <code>amt</code>.\n<p>@param [Numeric, Vector2D] other @param [Numeric] …\n"],["limit","Math2D::Vector2D","Math2D/Vector2D.html#method-i-limit","(max)","<p>Limit the magnitude of <code>self</code> to <code>max</code> and returns a new vector.\n<p>@param [Numeric] max @return [Vector2D]\n"],["magnitude","Math2D::Vector2D","Math2D/Vector2D.html#method-i-magnitude","()","<p>Returns the magnitude of <code>self</code>.\n<p>@return [Float]\n"],["map","Math2D::Utils2D","Math2D/Utils2D.html#method-c-map","(value, a1, a2, b1, b2)","<p>Re-maps a number from one range (<code>a1</code>..<code>a2</code>) to another (<code>b1</code>..<code>b2</code>).\n<p>@param [Numeric] value @param [Numeric] …\n"],["negate","Math2D::Vector2D","Math2D/Vector2D.html#method-i-negate","()",""],["new","Math2D::Vector2D","Math2D/Vector2D.html#method-c-new","(x = 0, y = 0)","<p>Creates a new vector (x, y).\n<p>@param [Numeric] x @param [Numeric] y @return [Vector2D]\n"],["noise","Math2D::Utils2D","Math2D/Utils2D.html#method-c-noise","(x, y = 0)","<p>Returns the Perlin noise value at specified coordinates. Perlin noise is a random sequence generator …\n"],["normalize","Math2D::Utils2D","Math2D/Utils2D.html#method-c-normalize","(value, a, b)","<p>Normalizes a number from another range (<code>a</code>..<code>b</code>) into a value between 0 and 1.\n<p>@param [Numeric] value @param …\n"],["normalize","Math2D::Vector2D","Math2D/Vector2D.html#method-i-normalize","()","<p>Normalizes <code>self</code> (set the magnitude to 1). <code>unit</code> is an alias for this method.\n<p>@return [Vector2D]\n"],["normalized?","Math2D::Vector2D","Math2D/Vector2D.html#method-i-normalized-3F","()","<p>Returns true if the magnitude of <code>self</code> is equal to 1, false otherwise. <code>unit?</code> is an alias for this method. …\n"],["one","Math2D::Vector2D","Math2D/Vector2D.html#method-c-one","()","<p>Shorthand for writing Vector2D.new(1, 1).\n<p>@return [Vector2D]\n"],["random","Math2D::Vector2D","Math2D/Vector2D.html#method-c-random","()","<p>Returns a new Vector2D with random components but magnitude equal to 1.\n<p>@return [Vector2D]\n"],["random_gradient","Math2D::Utils2D","Math2D/Utils2D.html#method-c-random_gradient","(ix, iy)","<p>@private @see en.wikipedia.org/wiki/Perlin_noise\n"],["ratio","Math2D::Vector2D","Math2D/Vector2D.html#method-i-ratio","()","<p>Returns the ratio (x / y) of <code>self</code>.\n<p>@return [Float]\n"],["reflect","Math2D::Vector2D","Math2D/Vector2D.html#method-i-reflect","(other)","<p>Reflects <code>self</code> and returns it as a new Vector2D. <code>other</code> is the normal of the plane where <code>self</code> is reflected. …\n"],["right","Math2D::Vector2D","Math2D/Vector2D.html#method-c-right","()","<p>Shorthand for writing Vector2D.new(1, 0).\n<p>@return [Vector2D]\n"],["rotate","Math2D::Vector2D","Math2D/Vector2D.html#method-i-rotate","(angle)","<p>Clockwise rotates <code>self</code> <code>angle</code> radians and returns it as a new Vector2D.\n<p>@param [Numeric] angle @return …\n"],["rotate_around","Math2D::Vector2D","Math2D/Vector2D.html#method-i-rotate_around","(pivot, angle)","<p>Clockwise rotates <code>self</code> <code>angle</code> radians around a <code>pivot</code> point and returns it as a new Vector2D.\n<p>@param [Vector2D] …\n"],["set","Math2D::Vector2D","Math2D/Vector2D.html#method-i-set","(x = self.x, y = self.y)","<p>Sets the <code>x</code> and <code>y</code> components of the vector. Each argument is optional, so you can change a single component …\n"],["set_magnitude","Math2D::Vector2D","Math2D/Vector2D.html#method-i-set_magnitude","(new_mag)","<p>Sets the magnitude of <code>self</code> to <code>new_mag</code>.\n<p>@param [Numeric] new_mag @return [Vector2D]\n"],["squared","Math2D::Vector2D","Math2D/Vector2D.html#method-i-squared","()","<p>Returns the magnitude squared of <code>self</code>.\n<p>@return [Numeric]\n"],["to_a","Math2D::Vector2D","Math2D/Vector2D.html#method-i-to_a","()","<p>Converts <code>self</code> to an array.\n<p>@return [Array&lt;Numeric&gt;]\n"],["to_deg","Math2D::Utils2D","Math2D/Utils2D.html#method-c-to_deg","(angle)","<p>Returns <code>angle</code> radians in degrees.\n<p>@param [Numeric] angle @return [Float]\n"],["to_rad","Math2D::Utils2D","Math2D/Utils2D.html#method-c-to_rad","(angle)","<p>Returns <code>angle</code> degrees in radians.\n<p>@param [Numeric] angle @return [Float]\n"],["to_s","Math2D::Vector2D","Math2D/Vector2D.html#method-i-to_s","()","<p>Converts <code>self</code> to a string.\n<p>@return [String]\n"],["to_vector","Math2D::Vector2D","Math2D/Vector2D.html#method-c-to_vector","(arr)","<p>Returns a new Vector2D from an array <code>arr</code>. If the array is bigger than 2 elements, only the first 2 will …\n"],["unit","Math2D::Vector2D","Math2D/Vector2D.html#method-i-unit","()",""],["unit?","Math2D::Vector2D","Math2D/Vector2D.html#method-i-unit-3F","()",""],["up","Math2D::Vector2D","Math2D/Vector2D.html#method-c-up","()","<p>Shorthand for writing Vector2D.new(0, -1). NOTE: the y-axis is inverted as per Ruby2D&#39;s y-axis orientation …\n"],["y_heading","Math2D::Vector2D","Math2D/Vector2D.html#method-i-y_heading","()","<p>Returns the y-heading angle of <code>self</code> in radians. The y-heading angle is the angle formed between <code>self</code> …\n"],["zero","Math2D::Vector2D","Math2D/Vector2D.html#method-c-zero","()","<p>Shorthand for writing Vector2D.new(0, 0).\n<p>@return [Vector2D]\n"]]}}